properties([
pipelineTriggers([parameterizedCron('''TZ=Asia/Kolkata 
		10 * * * * %ExecutionSuite=DemoDataIngestion;ExecutionEnvironment=ProdUS;LicenseCode=aa1326d6;XmlName=DataCreation_testng.xml
		20 * * * * %ExecutionSuite=DemoDataIngestion;ExecutionEnvironment=ProdUS;LicenseCode=aa1326d6;XmlName=DataCreation_testng1.xml
        ''')]),
	parameters([
		[
			$class: 'ChoiceParameter', 
			choiceType: 'PT_RADIO', 
			filterLength: 1, 
			filterable: false, 
			name: 'ExecutionSuite', 
			randomName: 'choice-parameter-453857694696436', 
			script: [
				$class: 'GroovyScript', 
				fallbackScript: [classpath: [], sandbox: false, script: ''], 
				script: [
					classpath: [], 
					sandbox: false, 
					script: '''return[
					\'MobileSDKSuite\',
					\'DemoDataIngestion:selected\',
					\'Test Data Creation\'
					]'''
				]
			]
		], 
        string(name: 'LicenseCode', defaultValue: 'aa1326d6', description: 'LicenseCode'),
        string(name: 'XmlName', defaultValue: 'DataCreation_testng.xml', description: 'XML File Name'),
        string(name: 'AgentName', defaultValue: 'testing', description: 'AgentName'),
		[
			$class: 'ChoiceParameter', 
			choiceType: 'PT_RADIO', 
			filterLength: 1, 
			filterable: false, 
			name: 'ExecutionEnvironment', 
			randomName: 'choice-parameter-16678591219581631', 
			script: [
				$class: 'GroovyScript', 
				fallbackScript: [classpath: [], sandbox: false, script: ''], 
				script: [
					classpath: [], 
					sandbox: false, 
					script: '''return[
					\'ProdUS\',
					\'ProdIN\',
					\'Staging\',
					\'QA\'
					]''']
				]
			],
			
	])
])
slackExecutionMessage = "message"
colorValue = "color"
BuildNumber="${env.BUILD_NUMBER}"
agentName=params.AgentName
slackThreadResponse=""
pipeline {
  agent {label agentName}
  tools {
    maven "Maven"
  }
  options {
    buildDiscarder(logRotator(numToKeepStr: '20'))
    timestamps()
    skipDefaultCheckout()
  }
  stages {
    	stage('Passed values'){
            agent {label agentName}
            steps {
                script {
                    println("ExecutionSuite->"+ExecutionSuite)
                    println("Lc->"+params.LicenseCode)
                    println("Xml->"+params.XmlName)
                    println("env->"+params.ExecutionEnvironment)
                    println("AgentName->"+params.AgentName)
                }
           	 }       
    }
     	    stage('Mobile SDK Event Injestion'){
     	        agent {label agentName}
     	        when {
        	          expression {
        	        	(params.ExecutionSuite=='DemoDataIngestion' )
        	     	}
        	     }
        	     stages{
         	        stage('Build') {
        	            steps {
            	            script {
            	            	checkout scm
            	            	runXml(XmlName)
            	            }
            	        }
            	        post {
	       					always {
	          					step([$class: 'Publisher', reportFilenamePattern: '**/testng-results.xml'])
	          					script{
      	 								summary = junit testResults: 'target\\surefire-reports\\*.xml'	
         								def passed = "${summary.passCount}" as Double
         								passCount = passed
         								def failed = "${summary.failCount}" as Integer
         								failureCount = failed
         								def percentage=((passed/(passed+failed))*100).round(2)
         								def testSummary="\n\n\n*Test Summary* \n Total: ${summary.totalCount}; Failures: ${summary.failCount}; Skipped: ${summary.skipCount}; Success %: ${percentage}"
        								slackBlockMessage(failed,"${summary.totalCount}",percentage,"${summary.skipCount}")
       }
	        				}
      					}
        	         }
        	     }
     	    }
  }
}
def runXml(xmlName) {
println("Running Xml->"+xmlName);
def lc = params.LicenseCode
 if(isUnix()){
 	sh 'mvn clean compiler:compile'
	sh "mvn -Dset.Environment=${ExecutionEnvironment} -Dset.LicenseCode=${lc} -DsuiteXmlFile=${xmlName} test" 
	}
 else{
 	bat 'mvn clean compiler:compile'
	bat "mvn -Dset.Environment=\"${ExecutionEnvironment}\" -Dset.LicenseCode=\"${lc}\" -DsuiteXmlFile=\"${xmlName}\" test"
	}	 
}


def slackMessage() {
  if (currentBuild.currentResult == "SUCCESS") {
    slackExecutionMessage = "Mobile users have been successfully created on *${ExecutionEnvironment}* for account having license code as *${LicenseCode}*";
    colorValue = '#00f61d';
  } else {
    slackExecutionMessage = "Mobile user creation failed for account *${LicenseCode}* of *${ExecutionEnvironment}* environment ";
    colorValue = '#df1019';
  }
}

def slackMessageforCampaigns() {
  if (currentBuild.currentResult == "SUCCESS") {
    slackExecutionMessage = "Successfully validated campaigns that were delivered on mobile device";
    colorValue = '#00f61d';
  } else {
    slackExecutionMessage = "Validation of campaigns on mobile device failed";
    colorValue = '#df1019';
  }
  }
  
def sendMultipleFilesToSlack(directoryPath,channel,initialComment){
	def files = findFiles(glob: """**/${directoryPath}/*.png""")
	            for (int i = 0; i < files.size(); i++) {
	                def filename = files[i]				 
					if(files[i].path.startsWith(directoryPath)){
	                    echo "${filename}"
						slackUploadFile(channel: channel, filePath:"${files[i]}", initialComment: initialComment)
					}
				}
}

def statusIcon(percentage){
	if( currentBuild.currentResult == "SUCCESS" ){
		return "https://cdn-icons-png.flaticon.com/512/190/190411.png"
	}else{
		return percentage<95?"https://cdn-icons-png.flaticon.com/512/190/190406.png":"https://cdn-icons-png.flaticon.com/512/1041/1041891.png"
	}
}

def slackBlockMessage(failedCount,totalCount,percentage,skipCount){
	iconURL=statusIcon(percentage)
	suiteName = params.ExecutionSuite
	uiBlocks = [
	    [      
			"type": "header",
			"text": [
				"type": "plain_text",
				"text": "${env.JOB_NAME} - ${suiteName} [Build #${env.BUILD_NUMBER}]",
				"emoji": true
			]
		],
		[
			"type": "divider"
		],
		[
			"type": "section",
			"fields": [
				[
					"type": "mrkdwn",
					"text": "Environment : \n*${ExecutionEnvironment}*"
				]
			]
		],
		[
			"type": "divider"
		],
		[
			"type": "context",
			"elements": [
				[
					"type": "plain_text",
					"text": "Test Summary",
					"emoji": true
				]
			]
		],
		[
			"type": "section",
			"fields": [
				[
					"type": "mrkdwn",
					"text": "*Total:*\n${totalCount}"
				],
				[
					"type": "mrkdwn",
					"text": "*Failure:*\n${failedCount}"
				],
				[
					"type": "mrkdwn",
					"text": "*Skipped:*\n${skipCount}"
				],
				[
					"type": "mrkdwn",
					"text": "*Percentage:*\n${percentage}%"
				]
			],
			"accessory": [
				"type": "image",
				"image_url": "${iconURL}",
				"alt_text": "status icon"
			]
		],
		[
			"type": "divider"
		],
		[
			"type": "actions",
			"elements": [
				[
					"type": "button",
					"text": [
						"type": "plain_text",
						"text": "Build Details ",
						"emoji": true
					],
					"value": "click_me_123",
					"url": "https://jenkins.stg.webengage.biz/job/${JOB_NAME}/${env.BUILD_NUMBER}/testReport/",
					"action_id": "actionId-0"
				]
			]
		],
		[
			"type": "divider"
		]
]
	sendSlackThreadMessage(uiBlocks)	
}
def sendSlackThreadMessage(def blocks){
   	slackResponse=""
	if(slackThreadResponse=="")
	    slackResponse=slackSend(channel: "jenkins-automation-develop-test" ,blocks:blocks)
	else
	    slackResponse=slackSend(channel: slackThreadResponse,replyBroadcast: true,blocks:blocks)
	if(suiteName=='Data Analytics Regression')
		slackThreadId= slackResponse.channelId +","+slackResponse.ts
	else	
		slackThreadId=slackResponse.ts			
}
